# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BotService::Mgmt::V2018_07_12_preview
  module Models
    #
    # The parameters to provide for the Facebook channel.
    #
    class FacebookChannelProperties

      include MsRestAzure

      # @return [String] Verify token. Value only returned through POST to the
      # action Channel List API, otherwise empty.
      attr_accessor :verify_token

      # @return [Array<FacebookPage>] The list of Facebook pages
      attr_accessor :pages

      # @return [String] Facebook application id
      attr_accessor :app_id

      # @return [String] Facebook application secret. Value only returned
      # through POST to the action Channel List API, otherwise empty.
      attr_accessor :app_secret

      # @return [String] Callback Url
      attr_accessor :callback_url

      # @return [Boolean] Whether this channel is enabled for the bot
      attr_accessor :is_enabled


      #
      # Mapper for FacebookChannelProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'FacebookChannelProperties',
          type: {
            name: 'Composite',
            class_name: 'FacebookChannelProperties',
            model_properties: {
              verify_token: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'verifyToken',
                type: {
                  name: 'String'
                }
              },
              pages: {
                client_side_validation: true,
                required: false,
                serialized_name: 'pages',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'FacebookPageElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'FacebookPage'
                      }
                  }
                }
              },
              app_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'appId',
                type: {
                  name: 'String'
                }
              },
              app_secret: {
                client_side_validation: true,
                required: true,
                serialized_name: 'appSecret',
                type: {
                  name: 'String'
                }
              },
              callback_url: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'callbackUrl',
                type: {
                  name: 'String'
                }
              },
              is_enabled: {
                client_side_validation: true,
                required: true,
                serialized_name: 'isEnabled',
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
